import IPartConstructor from "./parts/IPartConstructor";
import ITagConstructor from "./tags/ITagConstructor";
import ICulture from "./cultures/ICulture";
type OptionsType = {
    delimiters?: {
        start?: string;
        end?: string;
    };
    locale?: string;
};
/**
 * YumTemplate
 */
declare class YumTemplate {
    private readonly _options;
    private readonly _parts;
    private _zip;
    static registerCulture(locale: string, culture: ICulture): void;
    static registerPart(name: string, Part: IPartConstructor): void;
    static registerTag(name: string, Tag: ITagConstructor): void;
    static setExpressionEval(evaluate: (expression: string, context: Record<string, unknown>) => Promise<unknown>, g?: unknown): void;
    /**
     * constructor
     * @param options
     */
    constructor(options?: OptionsType);
    /**
     * _sanitizeOptions
     * @param options
     * @private
     */
    private _sanitizeOptions;
    /**
     * _loadNodePath
     * @param path
     * @private
     */
    private _loadNodePath;
    /**
     * _loadAnythingElse
     * @param handle
     * @private
     */
    private _loadAnythingElse;
    /**
     * load
     * @param handle
     */
    load(handle: unknown): Promise<void>;
    /**
     * render
     * @param data
     */
    render(data?: Record<string, unknown>): Promise<string | undefined>;
    /**
     * saveAs
     * @param path
     */
    saveAs(path: string): Promise<void>;
}
/**
 * Default export
 */
export default YumTemplate;
